/* de26r.f -- translated by f2c (version 20000817).
   You must link the resulting object file with the libraries:
        -lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static integer c__26 = 26;

/* Subroutine */ int de26r_c(S_fp f, integer *m, integer *jstart, real *yx,
        real *x, real *h__, real *delty, real *df, real *rf, real *yp,
        real *ry, real *rfn, integer *ierr)
{
    /* Initialized data */

    static real c1 = .5f;
    static real c2 = .416666f;
    static real c3 = .375f;
    static real c4 = -.026388f;
    static integer imax = 6;
    static real p = .01f;
    static real eps = 1e-4f;

    /* System generated locals */
    integer df_dim1, df_offset, ry_dim1, ry_offset, i__1, i__2;
    real r__1;

    /* Local variables */
    extern /* Subroutine */ int de33r_c(S_fp, integer *, integer *, real *,
            real *, real *, real *, real *, real *, real *, real *, real *, 
            integer *);
    static real hold, xold;
    static integer i__, k;
    extern /* Subroutine */ int de28rp_c(integer *, integer *, real *, real *),
             utde12_c(integer *, integer *),
             de28rs_c(integer *, integer *, real *, real *, real *);
    static integer k1;
    static real rx[5];
    static integer iorder;
    static real alp;
    static logical bul2;

#define df_ref(a_1,a_2) df[(a_2)*df_dim1 + a_1]

    /* Parameter adjustments */
    --rfn;
    ry_dim1 = *m;
    ry_offset = 1 + ry_dim1 * 1;
    ry -= ry_offset;
    --yp;
    --rf;
    df_dim1 = *m;
    df_offset = 1 + df_dim1 * 1;
    df -= df_offset;
    --delty;
    --yx;

    /* Function Body */
    if (*jstart >= 0) {
        goto L3;
    }
    if (*ierr == 0) {
        goto L1;
    }
    *ierr = 0;
    goto L5;
L1:
    for (k = 1; k <= 4; ++k) {
        k1 = k + 1;
        i__1 = *m;
        for (i__ = 1; i__ <= i__1; ++i__) {
            df_ref(i__, k) = df_ref(i__, k) - df_ref(i__, k1);
/* L2: */
        }
    }
    goto L5;
L3:
    xold = *x;
    i__1 = *m;
    for (i__ = 1; i__ <= i__1; ++i__) {
        yp[i__] = yx[i__];
/* L4: */
    }
    *ierr = 0;
    if (*jstart != 0) {
        goto L5;
    }
    iorder = 5;
    (*f)(x, &yx[1], &rf[1], m);
    de33r_c((S_fp)f, m, &iorder, x, &yx[1], h__, &df[df_offset], rx,
            &ry[ry_offset], &rfn[1], &rf[1], &delty[1], &i__);
    goto L6;
L5:
    if (*h__ == hold) {
        goto L6;
    }
    alp = *h__ / hold;
    de28rp_c(m, &iorder, &alp, &df[df_offset]);
L6:
    i__1 = *m;
    for (i__ = 1; i__ <= i__1; ++i__) {
        yx[i__] = yp[i__] + df_ref(i__, 1) + df_ref(i__, 2) * c1 +
                 df_ref(i__, 3) * c2 + df_ref(i__, 4) * c3;
        rf[i__] = df_ref(i__, 1) + df_ref(i__, 2) + df_ref(i__, 3) +
                df_ref(i__, 4);
/* L7: */
    }
    *x = xold + *h__;
    i__1 = imax;
    for (k = 1; k <= i__1; ++k) {
        bul2 = TRUE_;
        i__2 = *m;
        for (i__ = 1; i__ <= i__2; ++i__) {
            delty[i__] = -rf[i__] * c3;
/* L8: */
        }
        (*f)(x, &yx[1], &rf[1], m);
        i__2 = *m;
        for (i__ = 1; i__ <= i__2; ++i__) {
            rf[i__] *= *h__;
            delty[i__] += rf[i__] * c3;
            yx[i__] = delty[i__] + yx[i__];
            if ((r__1 = yx[i__], abs(r__1)) <= p) {
                goto L9;
            }
            delty[i__] /= yx[i__];
L9:
            if ((r__1 = delty[i__], abs(r__1)) > eps) {
                bul2 = FALSE_;
            }
/* L10: */
        }
        if (bul2) {
            goto L13;
        }
/* L11: */
    }
    *ierr = 65;
    i__1 = *m;
    for (i__ = 1; i__ <= i__1; ++i__) {
        yx[i__] = yp[i__];
/* L12: */
    }
    *x = xold;
    goto L15;
L13:
    de28rs_c(m, &iorder, &rf[1], &df[df_offset], &delty[1]);
    i__1 = *m;
    for (i__ = 1; i__ <= i__1; ++i__) {
        delty[i__] = df_ref(i__, 5) * c4;
        yx[i__] += delty[i__];
/* L14: */
    }
L15:
    if (*ierr != 0) {
        utde12_c(ierr, &c__26);
    }
    *jstart = 1;
    hold = *h__;
    return 0;
} /* de26r_c */

#undef df_ref
