/* de33r.f -- translated by f2c (version 20000817).
   You must link the resulting object file with the libraries:
        -lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static integer c__33 = 33;

/* Subroutine */ int de33r_c(S_fp f, integer *m, integer *iorder, real *xn,
        real *yn, real *h__, real *df, real *x, real *y, real *rs, real *rf, 
        real *r__, integer *ierr)
{
    /* Initialized data */

    static real d__[45] = { 1.f,1.f,-2.f,1.f,-3.f,3.f,1.f,-4.f,6.f,-4.f,1.f,
            -5.f,10.f,-10.f,5.f,1.f,-6.f,15.f,-20.f,15.f,-6.f,1.f,-7.f,21.f,
            -35.f,35.f,-21.f,7.f,1.f,-8.f,28.f,-56.f,70.f,-56.f,28.f,-8.f,1.f,
            -9.f,36.f,-84.f,126.f,-126.f,84.f,-36.f,9.f };
    static real c__[10] = { 1.f,.5f,.416666f,.375f,.348611f,.329861f,.315591f,
            .305266f,.294868f,.149188f };

    /* System generated locals */
    integer df_dim1, df_offset, y_dim1, y_offset, i__1, i__2, i__3, i__4;

    /* Local variables */
    static integer i__, j, k, l;
    extern /* Subroutine */ int utde12_c(integer *, integer *),
            de28rs_c(integer *, integer *, real *, real *, real *);
    static integer j1, k1;
    static real r1;
    static integer io;

#define y_ref(a_1,a_2) y[(a_2)*y_dim1 + a_1]
#define df_ref(a_1,a_2) df[(a_2)*df_dim1 + a_1]

    /* Parameter adjustments */
    --r__;
    --rf;
    --rs;
    y_dim1 = *m;
    y_offset = 1 + y_dim1 * 1;
    y -= y_offset;
    df_dim1 = *m;
    df_offset = 1 + df_dim1 * 1;
    df -= df_offset;
    --yn;
    --x;

    /* Function Body */
    *ierr = 0;
    io = *iorder;
    if (*iorder <= 10) {
        goto L1;
    }
    *ierr = 1;
    io = 10;
L1:
    i__1 = *m;
    for (i__ = 1; i__ <= i__1; ++i__) {
        y_ref(i__, 1) = yn[i__];
/* L2: */
    }
    x[1] = *xn;
    (*f)(&x[1], &y_ref(1, 1), &df_ref(1, 1), m);
    i__1 = *m;
    for (i__ = 1; i__ <= i__1; ++i__) {
        df_ref(i__, 1) = df_ref(i__, 1) * *h__;
        rs[i__] = df_ref(i__, 1);
/* L3: */
    }
    if (*iorder == 1) {
        goto L13;
    }
    i__1 = io;
    for (k = 2; k <= i__1; ++k) {
        x[k] = x[k - 1] + *h__;
/* L4: */
    }
    i__1 = io;
    for (j = 2; j <= i__1; ++j) {
        j1 = j - 1;
        i__2 = j;
        for (k = 2; k <= i__2; ++k) {
            k1 = k - 1;
            i__3 = *m;
            for (i__ = 1; i__ <= i__3; ++i__) {
                y_ref(i__, k) = y_ref(i__, k1);
                i__4 = j1;
                for (l = 1; l <= i__4; ++l) {
                    y_ref(i__, k) = y_ref(i__, k) +
                            df_ref(i__, l) * c__[l - 1];
/* L5: */
                }
/* L6: */
            }
            (*f)(&x[k], &y_ref(1, k), &rf[1], m);
            i__3 = *m;
            for (i__ = 1; i__ <= i__3; ++i__) {
                rf[i__] *= *h__;
/* L7: */
            }
            if (k == j) {
                j1 = j;
            }
            de28rs_c(m, &j1, &rf[1], &df[df_offset], &r__[1]);
/* L8: */
        }
        i__2 = *m;
        for (i__ = 1; i__ <= i__2; ++i__) {
            i__3 = j;
            for (l = 2; l <= i__3; ++l) {
                r1 = 0.f;
                i__4 = j;
                for (k = l; k <= i__4; ++k) {
                    k1 = (j - 1) * (j - 2) / 2 + k - l + 1;
                    r1 += df_ref(i__, k) * d__[k1 - 1];
/* L9: */
                }
                df_ref(i__, l) = r1;
/* L10: */
            }
            df_ref(i__, 1) = rs[i__];
/* L11: */
        }
/* L12: */
    }
L13:
    if (*ierr != 0) {
        utde12_c(ierr, &c__33);
    }
    return 0;
} /* de33r_c */

#undef df_ref
#undef y_ref
